"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoginForm = void 0;
var zod_1 = require("@hookform/resolvers/zod");
var react_1 = __importDefault(require("react"));
var react_hook_form_1 = require("react-hook-form");
var react_native_keyboard_controller_1 = require("react-native-keyboard-controller");
var z = __importStar(require("zod"));
var ui_1 = require("../components/ui");
var schema = z.object({
    name: z.string().optional(),
    email: z
        .string({
        required_error: 'Email is required',
    })
        .email('Invalid email format'),
    password: z
        .string({
        required_error: 'Password is required',
    })
        .min(6, 'Password must be at least 6 characters'),
});
var LoginForm = function (_a) {
    var _b = _a.onSubmit, onSubmit = _b === void 0 ? function () { } : _b;
    var _c = (0, react_hook_form_1.useForm)({
        resolver: (0, zod_1.zodResolver)(schema),
    }), handleSubmit = _c.handleSubmit, control = _c.control;
    return (<react_native_keyboard_controller_1.KeyboardAvoidingView style={{ flex: 1 }} behavior="padding" keyboardVerticalOffset={10}>
      <ui_1.View className="flex-1 justify-center p-4">
        <ui_1.Text testID="form-title" className="pb-6 text-center text-2xl">
          Sign In
        </ui_1.Text>

        <ui_1.ControlledInput testID="name" control={control} name="name" label="Name"/>

        <ui_1.ControlledInput testID="email-input" control={control} name="email" label="Email"/>
        <ui_1.ControlledInput testID="password-input" control={control} name="password" label="Password" placeholder="***" secureTextEntry={true}/>
        <ui_1.Button testID="login-button" label="Login" onPress={handleSubmit(onSubmit)}/>
      </ui_1.View>
    </react_native_keyboard_controller_1.KeyboardAvoidingView>);
};
exports.LoginForm = LoginForm;
//# sourceMappingURL=login-form.js.map