"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var tailwind_variants_1 = require("tailwind-variants");
var button = (0, tailwind_variants_1.tv)({
    slots: {
        container: 'my-2 flex flex-row items-center justify-center rounded-md px-4',
        label: 'font-inter text-base font-semibold',
        indicator: 'h-6 text-white',
    },
    variants: {
        variant: {
            default: {
                container: 'bg-black dark:bg-white',
                label: 'text-white dark:text-black',
                indicator: 'text-white dark:text-black',
            },
            secondary: {
                container: 'bg-primary-600',
                label: 'text-secondary-600',
                indicator: 'text-white',
            },
            outline: {
                container: 'border border-neutral-400',
                label: 'text-black dark:text-neutral-100',
                indicator: 'text-black dark:text-neutral-100',
            },
            destructive: {
                container: 'bg-red-600',
                label: 'text-white',
                indicator: 'text-white',
            },
            ghost: {
                container: 'bg-transparent',
                label: 'text-black underline dark:text-white',
                indicator: 'text-black dark:text-white',
            },
            link: {
                container: 'bg-transparent',
                label: 'text-black',
                indicator: 'text-black',
            },
        },
        size: {
            default: {
                container: 'h-10 px-4',
                label: 'text-base',
            },
            lg: {
                container: 'h-12 px-8',
                label: 'text-xl',
            },
            sm: {
                container: 'h-8 px-3',
                label: 'text-sm',
                indicator: 'h-2',
            },
            icon: { container: 'size-9' },
        },
        disabled: {
            true: {
                container: 'bg-neutral-300 dark:bg-neutral-300',
                label: 'text-neutral-600 dark:text-neutral-600',
                indicator: 'text-neutral-400 dark:text-neutral-400',
            },
        },
        fullWidth: {
            true: {
                container: '',
            },
            false: {
                container: 'self-center',
            },
        },
    },
    defaultVariants: {
        variant: 'default',
        disabled: false,
        fullWidth: true,
        size: 'default',
    },
});
exports.Button = react_1.default.forwardRef(function (_a, ref) {
    var text = _a.label, _b = _a.loading, loading = _b === void 0 ? false : _b, _c = _a.variant, variant = _c === void 0 ? 'default' : _c, _d = _a.disabled, disabled = _d === void 0 ? false : _d, _e = _a.size, size = _e === void 0 ? 'default' : _e, _f = _a.className, className = _f === void 0 ? '' : _f, testID = _a.testID, _g = _a.textClassName, textClassName = _g === void 0 ? '' : _g, props = __rest(_a, ["label", "loading", "variant", "disabled", "size", "className", "testID", "textClassName"]);
    var styles = react_1.default.useMemo(function () { return button({ variant: variant, disabled: disabled, size: size }); }, [variant, disabled, size]);
    return (<react_native_1.Pressable disabled={disabled || loading} className={styles.container({ className: className })} {...props} ref={ref} testID={testID}>
        {props.children ? (props.children) : (<>
            {loading ? (<react_native_1.ActivityIndicator size="small" className={styles.indicator()} testID={testID ? "".concat(testID, "-activity-indicator") : undefined}/>) : (<react_native_1.Text testID={testID ? "".concat(testID, "-label") : undefined} className={styles.label({ className: textClassName })}>
                {text}
              </react_native_1.Text>)}
          </>)}
      </react_native_1.Pressable>);
});
//# sourceMappingURL=button.js.map