"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Switch = exports.SwitchIcon = exports.Radio = exports.RadioIcon = exports.Checkbox = exports.CheckboxIcon = exports.Root = void 0;
var moti_1 = require("moti");
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var react_native_svg_1 = __importStar(require("react-native-svg"));
var colors_1 = __importDefault(require("../../components/ui/colors"));
var style_utils_1 = require("../../library/style-utils");
var text_1 = require("./text");
var SIZE = 20;
var WIDTH = 50;
var HEIGHT = 28;
var THUMB_HEIGHT = 22;
var THUMB_WIDTH = 22;
var THUMB_OFFSET = 4;
var Root = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b, children = _a.children, onChange = _a.onChange, disabled = _a.disabled, _c = _a.className, className = _c === void 0 ? '' : _c, props = __rest(_a, ["checked", "children", "onChange", "disabled", "className"]);
    var handleChange = (0, react_1.useCallback)(function () {
        onChange(!checked);
    }, [onChange, checked]);
    return (<react_native_1.Pressable onPress={handleChange} className={"flex-row items-center ".concat(className, " ").concat(disabled ? 'opacity-50' : '')} accessibilityState={{ checked: checked }} disabled={disabled} {...props}>
      {children}
    </react_native_1.Pressable>);
};
exports.Root = Root;
var Label = function (_a) {
    var text = _a.text, testID = _a.testID, _b = _a.className, className = _b === void 0 ? '' : _b;
    return (<text_1.Text testID={testID} className={" ".concat(className, " pl-2")}>
      {text}
    </text_1.Text>);
};
var CheckboxIcon = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b, _c = _a.backgroundColor, backgroundColor = _c === void 0 ? colors_1.default.primary[300] : _c, _d = _a.borderRadius, borderRadius = _d === void 0 ? 5 : _d;
    var color = checked ? (0, style_utils_1.getColor)(backgroundColor) : colors_1.default.charcoal[400];
    return (<moti_1.MotiView style={{
            height: SIZE,
            width: SIZE,
            borderColor: color,
            borderRadius: borderRadius,
        }} className="items-center justify-center border-2" from={{ backgroundColor: 'transparent', borderColor: '#CCCFD6' }} animate={{
            backgroundColor: checked ? color : 'transparent',
            borderColor: color,
        }} transition={{
            backgroundColor: { type: 'timing', duration: 100 },
            borderColor: { type: 'timing', duration: 100 },
        }}>
      <moti_1.MotiView from={{ opacity: 0 }} animate={{ opacity: checked ? 1 : 0 }} transition={{ opacity: { type: 'timing', duration: 100 } }}>
        <react_native_svg_1.default width="24" height="24" viewBox="0 0 24 24" fill="none">
          <react_native_svg_1.Path d="m16.726 7-.64.633c-2.207 2.212-3.878 4.047-5.955 6.158l-2.28-1.928-.69-.584L6 12.66l.683.577 2.928 2.477.633.535.591-.584c2.421-2.426 4.148-4.367 6.532-6.756l.633-.64L16.726 7Z" fill="#fff"/>
        </react_native_svg_1.default>
      </moti_1.MotiView>
    </moti_1.MotiView>);
};
exports.CheckboxIcon = CheckboxIcon;
var CheckboxRoot = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b, children = _a.children, props = __rest(_a, ["checked", "children"]);
    return (<exports.Root checked={checked} accessibilityRole="checkbox" {...props}>
      {children}
    </exports.Root>);
};
var CheckboxBase = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b, testID = _a.testID, label = _a.label, backgroundColor = _a.backgroundColor, borderRadius = _a.borderRadius, props = __rest(_a, ["checked", "testID", "label", "backgroundColor", "borderRadius"]);
    return (<CheckboxRoot checked={checked} testID={testID} {...props}>
      <exports.CheckboxIcon checked={checked} backgroundColor={backgroundColor} borderRadius={borderRadius}/>
      {label ? (<Label text={label} testID={testID ? "".concat(testID, "-label") : undefined} className="pr-2"/>) : null}
    </CheckboxRoot>);
};
exports.Checkbox = Object.assign(CheckboxBase, {
    Icon: exports.CheckboxIcon,
    Root: CheckboxRoot,
    Label: Label,
});
var RadioIcon = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b;
    var color = checked ? colors_1.default.primary[300] : colors_1.default.charcoal[400];
    return (<moti_1.MotiView style={{
            height: SIZE,
            width: SIZE,
            borderColor: color,
        }} className="items-center justify-center rounded-[20px] border-2 bg-transparent" from={{ borderColor: '#CCCFD6' }} animate={{
            borderColor: color,
        }} transition={{ borderColor: { duration: 100, type: 'timing' } }}>
      <moti_1.MotiView className={"size-[10px] rounded-[10px] ".concat(checked && 'bg-primary-300', " ")} from={{ opacity: 0 }} animate={{ opacity: checked ? 1 : 0 }} transition={{ opacity: { duration: 50, type: 'timing' } }}/>
    </moti_1.MotiView>);
};
exports.RadioIcon = RadioIcon;
var RadioRoot = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b, children = _a.children, props = __rest(_a, ["checked", "children"]);
    return (<exports.Root checked={checked} accessibilityRole="radio" {...props}>
      {children}
    </exports.Root>);
};
var RadioBase = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b, testID = _a.testID, label = _a.label, props = __rest(_a, ["checked", "testID", "label"]);
    return (<RadioRoot checked={checked} testID={testID} {...props}>
      <exports.RadioIcon checked={checked}/>
      {label ? (<Label text={label} testID={testID ? "".concat(testID, "-label") : undefined}/>) : null}
    </RadioRoot>);
};
exports.Radio = Object.assign(RadioBase, {
    Icon: exports.RadioIcon,
    Root: RadioRoot,
    Label: Label,
});
var SwitchIcon = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b;
    var translateX = checked
        ? THUMB_OFFSET
        : WIDTH - THUMB_WIDTH - THUMB_OFFSET;
    var backgroundColor = checked ? colors_1.default.primary[300] : colors_1.default.charcoal[400];
    return (<react_native_1.View className="w-[50px] justify-center">
      <react_native_1.View className="overflow-hidden rounded-full">
        <react_native_1.View style={{
            width: WIDTH,
            height: HEIGHT,
            backgroundColor: backgroundColor,
        }}/>
      </react_native_1.View>
      <moti_1.MotiView style={{
            height: THUMB_HEIGHT,
            width: THUMB_WIDTH,
            position: 'absolute',
            backgroundColor: 'white',
            borderRadius: 13,
            right: 0,
        }} animate={{
            translateX: react_native_1.I18nManager.isRTL ? translateX : -translateX,
        }} transition={{ translateX: { overshootClamping: true } }}/>
    </react_native_1.View>);
};
exports.SwitchIcon = SwitchIcon;
var SwitchRoot = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b, children = _a.children, props = __rest(_a, ["checked", "children"]);
    return (<exports.Root checked={checked} accessibilityRole="switch" {...props}>
      {children}
    </exports.Root>);
};
var SwitchBase = function (_a) {
    var _b = _a.checked, checked = _b === void 0 ? false : _b, testID = _a.testID, label = _a.label, props = __rest(_a, ["checked", "testID", "label"]);
    return (<SwitchRoot checked={checked} testID={testID} {...props}>
      <exports.SwitchIcon checked={checked}/>
      {label ? (<Label text={label} testID={testID ? "".concat(testID, "-label") : undefined}/>) : null}
    </SwitchRoot>);
};
exports.Switch = Object.assign(SwitchBase, {
    Icon: exports.SwitchIcon,
    Root: SwitchRoot,
    Label: Label,
});
//# sourceMappingURL=checkbox.js.map