import * as React from 'react';
import type { FieldValues } from 'react-hook-form';
import type { InputControllerType } from './input';
export type OptionType = {
    label: string;
    value: string | number;
};
type OptionsProps = {
    options: OptionType[];
    onSelect: (option: OptionType) => void;
    value?: string | number;
    testID?: string;
};
export declare const Options: React.ForwardRefExoticComponent<OptionsProps & React.RefAttributes<import("@gorhom/bottom-sheet/lib/typescript/types").BottomSheetModalMethods>>;
export interface SelectProps {
    value?: string | number;
    label?: string;
    disabled?: boolean;
    error?: string;
    options?: OptionType[];
    onSelect?: (value: string | number) => void;
    placeholder?: string;
    testID?: string;
}
interface ControlledSelectProps<T extends FieldValues> extends SelectProps, InputControllerType<T> {
}
export declare const Select: (props: SelectProps) => React.JSX.Element;
export declare function ControlledSelect<T extends FieldValues>(props: ControlledSelectProps<T>): React.JSX.Element;
export {};
//# sourceMappingURL=select.d.ts.map