"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var button_1 = __importDefault(require("./button"));
var blur_1 = require("@react-native-community/blur");
var text_1 = __importDefault(require("./text"));
var _a = react_native_1.Dimensions.get('window'), SCREEN_WIDTH = _a.width, SCREEN_HEIGHT = _a.height;
var CommonModal = function (_a) {
    var isVisible = _a.isVisible, mainTitle = _a.mainTitle, subTitle = _a.subTitle, onClose = _a.onClose, onConfirm = _a.onConfirm, _b = _a.cancelButton, cancelButton = _b === void 0 ? { text: '취소', variant: 'primaryLow' } : _b, _c = _a.confirmButton, confirmButton = _c === void 0 ? { text: '확인', variant: 'primary' } : _c;
    return (<react_native_1.View>
      <react_native_1.Modal visible={isVisible} transparent animationType="fade">
        <react_native_1.TouchableOpacity activeOpacity={1} onPress={onClose} style={{
            width: SCREEN_WIDTH,
            height: SCREEN_HEIGHT,
        }}>
          {react_native_1.Platform.OS === 'android' ? (<blur_1.BlurView style={{
                position: 'absolute',
                top: 0,
                left: 0,
                bottom: 0,
                right: 0,
            }} blurType="dark" blurAmount={10}/>) : (<react_native_1.Image style={{
                position: 'absolute',
                top: 0,
                left: 0,
                bottom: 0,
                right: 0,
            }} resizeMode="cover" source={require('./images/blurImg.png')} blurRadius={10}/>)}
          <react_native_1.View className="w-full h-full justify-center items-center">
            <react_native_1.View className="w-[80%] rounded-2xl p-[20px] bg-white">
              <react_native_1.View className="items-start gap-[4px] pt-4 pb-[12px]">
                <text_1.default face={'title'} weight={'bold'} size={'small'} textColor={'gray-900'}>
                  {mainTitle}
                </text_1.default>
                {subTitle && (<text_1.default face={'body'} weight={'regular'} size={'medium'} textColor={'gray-700'} className={'w-[78%]'}>
                    {subTitle}
                  </text_1.default>)}
              </react_native_1.View>

              <react_native_1.View className={"flex-row gap-2 ".concat(!onConfirm ? 'justify-center' : '')}>
                {onConfirm ? (<>
                    <button_1.default text={cancelButton.text} variant={cancelButton.variant} shape={cancelButton.shape} className={"flex-1 ".concat(cancelButton.className || '')} onPress={onClose}/>
                    <button_1.default text={confirmButton.text} variant={confirmButton.variant} shape={confirmButton.shape} className={"flex-1 ".concat(confirmButton.className || '')} onPress={onConfirm}/>
                  </>) : (<button_1.default text={confirmButton.text} variant={confirmButton.variant || 'danger'} shape={confirmButton.shape || 'round'} className={"flex-1 ".concat(confirmButton.className || '')} onPress={onClose}/>)}
              </react_native_1.View>
            </react_native_1.View>
          </react_native_1.View>
        </react_native_1.TouchableOpacity>
      </react_native_1.Modal>
    </react_native_1.View>);
};
exports.default = CommonModal;
//# sourceMappingURL=popup-modal.js.map