"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var style_utils_1 = require("./style-utils");
var react_1 = require("react");
var search_black_1 = require("./icons/search-black");
var search_gray_1 = require("./icons/search-gray");
var clear_gray_1 = require("./icons/clear-gray");
exports.default = React.forwardRef(function SearchBar(_a, ref) {
    var value = _a.value, _b = _a.placeholder, placeholder = _b === void 0 ? '검색어를 입력하세요' : _b, _c = _a.textColor, textColor = _c === void 0 ? 'black' : _c, _d = _a.placeholderColor, placeholderColor = _d === void 0 ? 'gray-400' : _d, _e = _a.backgroundColor, backgroundColor = _e === void 0 ? 'white' : _e, _f = _a.width, width = _f === void 0 ? 'w-full' : _f, _g = _a.height, height = _g === void 0 ? 'h-[48px]' : _g, _h = _a.radius, radius = _h === void 0 ? 'rounded-xl' : _h, _j = _a.border, border = _j === void 0 ? { borderWidth: '0', borderColor: 'transparent' } : _j, textStyle = _a.textStyle, className = _a.className, style = _a.style, _k = _a.disabled, disabled = _k === void 0 ? false : _k, onChangeText = _a.onChangeText, onClear = _a.onClear, onSubmit = _a.onSubmit, blurIcon = _a.blurIcon, onFocus = _a.onFocus, onBlur = _a.onBlur;
    var _l = (0, react_1.useState)(false), isFocused = _l[0], setIsFocused = _l[1];
    var getStatusStyles = function () {
        return isFocused
            ? {
                borderWidth: 2,
                borderColor: (0, style_utils_1.getColor)('#111827'),
                backgroundColor: 'white',
            }
            : { borderWidth: 0, backgroundColor: (0, style_utils_1.getColor)(backgroundColor) };
    };
    return (<react_native_1.View className={"\n        ".concat(width, " ").concat(height, " ").concat(radius, "\n        ").concat(disabled ? 'opacity-50' : '', "\n        ").concat(className || '', "\n      ")} style={[
            __assign({ borderColor: (0, style_utils_1.getColor)(border.borderColor) }, getStatusStyles()),
            !className && style,
        ]}>
      <react_native_1.View className="flex-row items-center h-full">
        <react_native_1.View className="pl-4">
          {isFocused ? <search_gray_1.SearchGrayIcon /> : blurIcon || <search_black_1.SearchBlackIcon />}
        </react_native_1.View>
        <react_native_1.TextInput ref={ref} value={value} placeholder={placeholder} onChangeText={onChangeText} onFocus={function () {
            setIsFocused(true);
            onFocus === null || onFocus === void 0 ? void 0 : onFocus();
        }} onBlur={function () {
            setIsFocused(false);
            onBlur === null || onBlur === void 0 ? void 0 : onBlur();
        }} onSubmitEditing={onSubmit} className="flex-1 px-2 h-full" style={[
            {
                color: (0, style_utils_1.getColor)(textColor),
            },
            textStyle,
        ]} placeholderTextColor={(0, style_utils_1.getColor)(placeholderColor)} editable={!disabled}/>
        {value && onClear && isFocused && (<react_native_1.TouchableOpacity activeOpacity={1} className="px-4 h-full justify-center" onPress={onClear}>
            <clear_gray_1.ClearGrayIcon />
          </react_native_1.TouchableOpacity>)}
      </react_native_1.View>
    </react_native_1.View>);
});
//# sourceMappingURL=search-bar.js.map