"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var text_1 = __importDefault(require("./text"));
var TEXT_BUTTON_PRESETS = {
    brand: {
        textColor: 'emerald-500', // #10B981
    },
    neutral: {
        textColor: 'gray-900',
    },
    neutralLow: {
        textColor: 'gray-500',
    },
    inverse: {
        textColor: 'white',
    },
};
var SIZE_PRESETS = {
    small: 'text-prime-text-13',
    medium: 'text-prime-text-15',
    large: 'text-prime-text-16',
};
function TextButton(_a) {
    var _b = _a.variant, variant = _b === void 0 ? 'neutral' : _b, _c = _a.size, size = _c === void 0 ? 'medium' : _c, text = _a.text, _d = _a.disabled, disabled = _d === void 0 ? false : _d, _e = _a.bold, bold = _e === void 0 ? false : _e, _f = _a.underline, underline = _f === void 0 ? false : _f, leftIcon = _a.leftIcon, rightIcon = _a.rightIcon, className = _a.className, onPress = _a.onPress;
    var preset = TEXT_BUTTON_PRESETS[variant];
    var getMarginStyle = function (gap, isLeft) {
        if (isLeft === void 0) { isLeft = true; }
        if (!gap)
            return {};
        if (typeof gap === 'number') {
            return isLeft ? { marginRight: gap } : { marginLeft: gap };
        }
        return { className: gap };
    };
    return (<react_native_1.TouchableOpacity activeOpacity={0.7} className={"flex-row items-center justify-center ".concat(className || '')} onPress={onPress} disabled={disabled}>
      <react_native_1.View className="flex-row items-center justify-center">
        {leftIcon && (<react_native_1.View {...getMarginStyle(leftIcon.gap, true)}>{leftIcon.icon}</react_native_1.View>)}

        <text_1.default face="body" size={size} weight={bold ? 'bold' : 'regular'} textColor={preset.textColor} className={"".concat(underline ? 'underline' : '', " ").concat(disabled ? 'opacity-50' : '')}>
          {text}
        </text_1.default>

        {rightIcon && (<react_native_1.View {...getMarginStyle(rightIcon.gap, false)}>
            {rightIcon.icon}
          </react_native_1.View>)}
      </react_native_1.View>
    </react_native_1.TouchableOpacity>);
}
exports.default = TextButton;
//# sourceMappingURL=text-button.js.map